#!/usr/bin/env python 
# Based on code from https://wiki.python.org/moin/BaseHttpServer

import time
import BaseHTTPServer
import urlparse
import urllib
import sys


HOST_NAME = ''
PORT_NUMBER = 9080 # Maybe set this to 9000.


class MyHandler(BaseHTTPServer.BaseHTTPRequestHandler):
    def do_HEAD(s):
        s.send_response(200)
        s.send_header("Content-type", "text/html")
        s.send_header("x-xss-protection", "0")
        s.end_headers()
    def do_GET(s):
        """Respond to a GET request."""
        if s.path[1:] == 'CRASH':
            s.server.socket.close()
        s.send_response(200)
        s.send_header("Content-type", "text/html")
        s.end_headers()
        s.wfile.write("<html><head><title>Title goes here.</title></head>")
        s.wfile.write("<body><form action='.' method='POST'><input name='sample' value='1' /><input type='submit' /></form><p>This is a test.</p>")
        # If someone went to "http://something.somewhere.net/foo/bar/",
        # then s.path equals "/foo/bar/".
        s.wfile.write("<p>You accessed path: %s</p>" % s.path[1:])
        s.wfile.write("</body></html>")

    def do_POST(s):
        """Respond to a POST request."""

        # Extract and print the contents of the POST
        length = int(s.headers['Content-Length'])
        post_data = urlparse.parse_qs(s.rfile.read(length).decode('utf-8'))
        for key, value in post_data.iteritems():
            print "%s=%s" % (key, value)

        s.send_response(200)
        s.send_header("Content-type", "text/html")
        s.end_headers()
        s.wfile.write("<html><head><title>Title goes here.</title></head>")
        s.wfile.write("<body><form action='.' method='POST'><input name='sample' value='1' /><input type='submit' /></form><p>This is a test.</p>")
        s.wfile.write("<p>You posted data:</p>")
        for key, value in post_data.iteritems():
            s.wfile.write("<p>%s=%s</p>" % (key, value))
        s.wfile.write("</body></html>")

if __name__ == '__main__':
    server_class = BaseHTTPServer.HTTPServer
    httpd = server_class((HOST_NAME, PORT_NUMBER), MyHandler)
    print time.asctime(), "Server Starts - %s:%s" % (HOST_NAME, PORT_NUMBER)
    try:
        httpd.serve_forever()
    except KeyboardInterrupt:
        pass
    httpd.server_close()
    print time.asctime(), "Server Stops - %s:%s" % (HOST_NAME, PORT_NUMBER)